# Payment

This is one of the services provided for partners to use Finnet e-money account balance to perform financial transactions like paying items or services. This will allow Finnet account balance to debit from partners' 3rd party application.

### Technical Specification <a href="#technical-specification" id="technical-specification"></a>

```
Service Code: 54
```

| Environment | Method | URL                                                             |
| ----------- | ------ | --------------------------------------------------------------- |
| Development | POST   | <https://snapstag.finnet.co.id/v1.0/debit/payment-host-to-host> |
| Production  | POST   | <https://snap.finnet.co.id/v1.0/debit/payment-host-to-host>     |

### Body Request <a href="#body-request" id="body-request"></a>

| No | Name               | Type                                                                    | Mandatory | Min Length | Max Length | Description                                       |
| -- | ------------------ | ----------------------------------------------------------------------- | --------- | ---------- | ---------- | ------------------------------------------------- |
| 1  | partnerReferenceNo | String                                                                  | M         | 1          | 64         | Transaction identifier on service consumer system |
| 2  | amount             | [Object](/api-reference/appendix/json-object/amount-object.md)          | M         | 1          | 2          | Transaction Amount                                |
| 3  | additionalInfo     | [Object](/api-reference/appendix/json-object/additional-info-object.md) | M         | 1          | 2          | Additional Info                                   |

#### Sample Request <a href="#sample-request" id="sample-request"></a>

```
{
  "partnerReferenceNo": "78912343452347891",
  "amount": {
    "value": "10000.00",
    "currency": "IDR"
  },
  "additionalInfo": {
    "transactionDesc": "Pulsa Rp. 500000",
    "transactionType": "TEST"
  }
}
```

### Body Response <a href="#body-response" id="body-response"></a>

| No | Name               | Type                                                              | Mandatory | Min Length | Max Length | Description                                       |
| -- | ------------------ | ----------------------------------------------------------------- | --------- | ---------- | ---------- | ------------------------------------------------- |
| 1  | responseCode       | [Enum](/api-reference/appendix/enumeration/response-code-list.md) | M         | 1          | 7          | BI SNAP Response Code.                            |
| 2  | responseMessage    | String                                                            | M         | 1          | 150        | BI SNAP Response Message.                         |
| 3  | referenceNo        | String                                                            | O         | 1          | 64         | Transaction identifier on service provider system |
| 4  | partnerReferenceNo | String                                                            | O         | 1          | 64         | Transaction identifier on service consumer system |

#### Sample Response <a href="#sample-response" id="sample-response"></a>

```
{
  "responseCode": "2005400",
  "responseMessage": "Request has been processed successfully",
  "referenceNo": "2212010005593297",
  "partnerReferenceNo": "78912343452347002"
}
```

### Response Code & Message <a href="#response-code--message" id="response-code--message"></a>

| No | HTTP Code | Code    | Message (Indonesian)            |
| -- | --------- | ------- | ------------------------------- |
| 1  | 200       | 2005400 | Successful                      |
| 2  | 400       | 4005400 | Bad request                     |
| 3  | 400       | 4005401 | Invalid field format {field}    |
| 4  | 400       | 4005402 | Invalid mandatory field {field} |
| 5  | 401       | 4015401 | Invalid token (B2B)             |
| 6  | 401       | 4015400 | Unauthorised. \[Reason]         |
| 7  | 403       | 4035401 | Feature not allowed             |
| 8  | 403       | 4035404 | Activity count limit exceeded   |
| 9  | 404       | 4045408 | Invalid merchant                |
| 10 | 500       | 5005400 | General error                   |
| 11 | 504       | 5045400 | Timeout                         |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.finpay.id/api-reference/finpay-money/linkage/direct-debit/payment.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
